﻿import mx.transitions.Tween;
import mx.transitions.easing.*;
import flash.filters.DropShadowFilter;
class ToolTip extends MovieClip {
	private var mcBg:MovieClip;
	private var mcBt:MovieClip;
	private var mcBb:MovieClip;
	private var mcBl:MovieClip;
	private var mcBr:MovieClip;
	private var tfLbl:TextField;
	private var ani:Tween;
	private var func:Function;
	private var interval:Number;
	private var tip:String;
	// =============== CUSTOMIZE ========================
	// set maximum number of characters
	private var maxC:Number = 100;
	// height of tooltip, not including borders
	private var h:Number = 16;
	// set border width
	private var borderWidth:Number = 1;
	// set left and right padding
	private var padding:Number = 3;
	// set how long the tooltip will stay visible
	// 0 stays until mouse rolls out
	private var stayInterval:Number = 6;
	// set tooltip show delay
	private var showDelay:Number = .5;
	// set true if you want tooltip to follow mouse
	private var mouseFollow:Boolean = false;
	// set true if you want tooltip to drop shadow
	private var dropShadow:Boolean = true;
	// x and y offsets from mouse pointer's tip
	private var offsetX:Number = 0;
	private var offsetY:Number = 20;
	// ==================================================
	public function ToolTip() {
		mcBg = eval(this._target+"/bg");
		mcBt = eval(this._target+"/bt");
		mcBb = eval(this._target+"/bb");
		mcBl = eval(this._target+"/bl");
		mcBr = eval(this._target+"/br");
		tfLbl = eval(this._target+"/lbl");
		tfLbl.autoSize = "left";
		tfLbl.selectable = false;
		tfLbl.multiline = false;
		tfLbl.wordWrap = false;
		tfLbl.text = "tip";
		tip = new String();
		//
		this._alpha = 0;
		mcBg._height = h;
		mcBg._x = mcBg._y=borderWidth;
		mcBt._height = mcBb._height=mcBl._width=mcBr._width=borderWidth;
		mcBl._height = mcBr._height=h;
		mcBl._y = mcBr._y=borderWidth;
		mcBb._y = 2*borderWidth+h;
		tfLbl._x = borderWidth+padding;
		tfLbl._y = borderWidth+h/2-tfLbl._height/2-1;
		this.resize();
		if (dropShadow) {
			this.drawShadow();
		}
	}
	private function resize() {
		var w:Number = Math.floor(tfLbl.textWidth+2+2*padding);
		mcBg._width = w;
		mcBt._width = mcBb._width=w+2*borderWidth;
		mcBr._x = 2*borderWidth+w;
	}
	public function Show(s:String) {
		tip = s;
		if (showDelay>0) {
			setTimeout(fadeIn, showDelay);
		} else {
			fadeIn();
		}
	}
	private function fadeIn() {
		if (interval != undefined) {
			clearInterval(interval);
		}
		delete ani.onMotionFinished;
		ani.stop();
		this._alpha = 0;
		this.swapDepths(this._parent.getNextHighestDepth());
		if (tip.length<=maxC) {
			tfLbl.text = tip;
		} else {
			tfLbl.text = tip.slice(0, maxC-1)+"...";
		}
		resize();
		if (!mouseFollow) {
			this._x = _root._xmouse+offsetX;
			this._y = _root._ymouse+offsetY;
			checkIfOutOfBounds();
		}
		ani = new Tween(this, "_alpha", None.easeOut, 0, 100, .25, true);
		ani.onMotionFinished = function() {
			with (this.obj) {
				if (stayInterval>0) {
					setTimeout(Hide, stayInterval);
				}
			}
		};
	}
	public function Hide() {
		if (interval != undefined) {
			clearInterval(interval);
		}
		delete ani.onMotionFinished;
		ani.stop();
		if (this._alpha<=0) {
			return;
		}
		ani = new Tween(this, "_alpha", None.easeOut, this._alpha, 0, .1, true);
	}
	private function setTimeout(f:Function, t:Number) {
		if (interval != undefined) {
			clearInterval(interval);
		}
		func = f;
		interval = setInterval(function (mc) {
			with (mc) {
				clearInterval(interval);
				func();
			}
		}, t*1000, this);
	}
	private function onEnterFrame() {
		if (mouseFollow) {
			this._x = _root._xmouse+offsetX;
			this._y = _root._ymouse+offsetY;
			checkIfOutOfBounds();
		}
	}
	private function drawShadow() {
		// customize shadow
		var distance:Number = 1.5;
		var angleInDegrees:Number = 45;
		var color:Number = 0x000000;
		var alpha:Number = .9;
		var blurX:Number = 3;
		var blurY:Number = 3;
		var strength:Number = .8;
		var quality:Number = 3;
		var inner:Boolean = false;
		var knockout:Boolean = false;
		var hideObject:Boolean = false;
		var filter:DropShadowFilter = new DropShadowFilter(distance, angleInDegrees, color, alpha, blurX, blurY, strength, quality, inner, knockout, hideObject);
		var filterArray:Array = new Array();
		filterArray.push(filter);
		this.filters = filterArray;
	}
	private function checkIfOutOfBounds() {
		if (this._x+this._width>Stage.width) {
			this._x = _root._xmouse-this._width;
		}
		if (this._y+this._height>Stage.height) {
			this._y = _root._ymouse-this._height;
		}
		this._x = Math.round(this._x);
		this._y = Math.round(this._y);
	}
}
